#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 3 "grammar"
#include <stdio.h>
#include "LookupDefs.i"
#include "ParserDefs.i"

int BitListLength;
struct StateRecord * ParserList;
extern int StateOffset;
extern char * StateBaseName;
extern char *ResetSignal;
extern struct NextState *ResetState; 
#line 14 "grammar"
typedef union { int                   ival;
	 char               * chval;
	 struct IdList      * idval;
	 struct NextState   * nsval;
	 struct CaseItem    *  cval;
	 struct StateRecord *  sval;
	 struct AssertList  *  aval;
       } YYSTYPE;
#line 37 "y.tab.c"
#define YYERRCODE 256
#define IDENTIFIER 257
#define INPUT 258
#define OUTPUT 259
#define CASE 260
#define IF 261
#define THEN 262
#define ELSE 263
#define ARROW 264
#define DEFAULT 265
#define ENDCASE 266
#define GOTO 267
#define NOT 268
#define COLON 269
#define SEMICOLON 270
#define LPAREN 271
#define RPAREN 272
#define ONEBIT 273
#define ZEROBIT 274
#define DONTCAREBIT 275
#define EQUALS 276
#define RESET 277
#define TO 278
#define STATETOKEN 279
#define ON 280
const short yylhs[] = {                                        -1,
    0,    4,    4,    5,    5,    6,    6,   14,   14,    7,
    7,    1,    1,   16,   16,   15,   15,    8,   17,    9,
    9,    9,    9,   10,   11,   11,    3,    3,    3,    2,
    2,   13,   13,   12,   12,
};
const short yylen[] = {                                         2,
    4,    4,    0,    4,    0,    6,    0,    2,    1,    1,
    2,    1,    2,    1,    3,    1,    2,    3,    0,    7,
    7,    8,    3,    4,    2,    1,    1,    1,    1,    2,
    1,    4,    2,    1,    4,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,   12,    0,    0,    0,
    0,   13,    2,    0,    0,    0,    0,   10,    4,    0,
    0,   11,    0,    0,    0,    0,   18,    0,    0,    9,
    0,    0,    0,    0,    0,    0,    8,    6,    0,    0,
    0,   23,    0,    0,   16,    0,    0,    0,    0,   35,
   17,    0,    0,    0,   28,   27,   29,   15,    0,   31,
   26,    0,    0,    0,    0,   30,    0,   25,   20,   21,
    0,    0,    0,   33,   22,   24,    0,   32,
};
const short yydgoto[] = {                                       2,
    8,   59,   60,    3,    6,   11,   17,   18,   27,   61,
   62,   30,   69,   31,   44,   45,   46,
};
const short yysindex[] = {                                   -243,
 -250,    0, -227, -239, -235, -242,    0, -247, -239, -228,
 -206,    0,    0, -241, -204, -215, -206,    0,    0, -222,
 -212,    0, -253, -211, -248, -199,    0, -210, -199,    0,
 -208, -239, -203, -194, -205, -193,    0,    0, -191, -199,
 -195,    0, -207, -255,    0, -202, -192, -199, -262,    0,
    0, -262, -199, -190,    0,    0,    0,    0, -233,    0,
    0, -229, -198, -199, -199,    0, -234,    0,    0,    0,
 -196, -189, -199,    0,    0,    0, -188,    0,
};
const short yyrindex[] = {                                   -252,
    0,    0, -249,    0,    0, -239,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -213,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -197,    0,
    0,    0, -251,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
   -8,    0,  -16,    0,    0,    0,    0,   59,    0,   15,
    0,  -26,    0,    0,    0,   34,    0,
};
#define YYTABLESIZE 82
const short yytable[] = {                                      35,
   14,   43,   37,   28,    3,   14,    3,    5,   33,   12,
   55,   56,   57,   47,    1,   12,   50,    7,    4,   34,
   14,   54,   13,   39,    3,   29,   63,    5,   19,   73,
   65,    5,   58,    9,   10,   74,   67,   71,   72,   55,
   56,   57,   66,   55,   56,   57,   77,   24,   25,   34,
   16,   15,   20,   21,   26,   23,   34,   28,   40,   32,
   36,   38,   41,   43,   42,   12,   48,    1,   49,   52,
   53,   70,   64,   75,   19,   22,   68,   51,    0,    0,
   76,   78,
};
const short yycheck[] = {                                      26,
    9,  257,   29,  257,  257,  257,  259,  257,  257,  257,
  273,  274,  275,   40,  258,  257,  272,  257,  269,  268,
  272,   48,  270,   32,  277,  279,   53,  277,  270,  264,
  264,  259,   49,  269,  277,  270,  266,   64,   65,  273,
  274,  275,   59,  273,  274,  275,   73,  260,  261,  263,
  257,  280,  257,  269,  267,  278,  270,  257,  262,  271,
  271,  270,  257,  257,  270,  257,  262,    0,  276,  272,
  263,  270,  263,  270,  272,   17,   62,   44,   -1,   -1,
  270,  270,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 280
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IDENTIFIER","INPUT","OUTPUT",
"CASE","IF","THEN","ELSE","ARROW","DEFAULT","ENDCASE","GOTO","NOT","COLON",
"SEMICOLON","LPAREN","RPAREN","ONEBIT","ZEROBIT","DONTCAREBIT","EQUALS","RESET",
"TO","STATETOKEN","ON",
};
const char * const yyrule[] = {
"$accept : program",
"program : InputList OutputList Reset StateList",
"InputList : INPUT COLON IdentifierList SEMICOLON",
"InputList :",
"OutputList : OUTPUT COLON IdentifierList SEMICOLON",
"OutputList :",
"Reset : RESET ON IDENTIFIER TO ResetState SEMICOLON",
"Reset :",
"ResetState : STATETOKEN NextState",
"ResetState : NextState",
"StateList : State",
"StateList : StateList State",
"IdentifierList : IDENTIFIER",
"IdentifierList : IdentifierList IDENTIFIER",
"Assert : IDENTIFIER",
"Assert : IDENTIFIER EQUALS Bit",
"AssertList : Assert",
"AssertList : AssertList Assert",
"State : IDENTIFIER COLON Control",
"$$1 :",
"Control : CASE LPAREN IdentifierList $$1 RPAREN Cases DefaultCase",
"Control : IF IDENTIFIER THEN NextState ELSE NextState SEMICOLON",
"Control : IF NOT IDENTIFIER THEN NextState ELSE NextState SEMICOLON",
"Control : GOTO NextState SEMICOLON",
"CaseStatement : BitList ARROW NextState SEMICOLON",
"Cases : Cases CaseStatement",
"Cases : CaseStatement",
"Bit : ZEROBIT",
"Bit : ONEBIT",
"Bit : DONTCAREBIT",
"BitList : BitList Bit",
"BitList : Bit",
"DefaultCase : ENDCASE ARROW NextState SEMICOLON",
"DefaultCase : ENDCASE SEMICOLON",
"NextState : IDENTIFIER",
"NextState : IDENTIFIER LPAREN AssertList RPAREN",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 437 "grammar"
#include "lex.yy.c"
#line 222 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 36 "grammar"
{ /***********************************************
			   * Return the parser data list in an external.
			   ***********************************************
			   */
			   ParserList=yyvsp[0].sval;
			   /*Generate($4);*/
			}
break;
case 2:
#line 45 "grammar"
{ /***********************************************
			   * Parse the list of input signals for the fsm.
			   * Once the list has been parsed, add the
			   * signals to the symbol table.
			   ***********************************************
			   */
			   AddListItems(INPUTS, yyvsp[-1].idval);
			}
break;
case 3:
#line 53 "grammar"
{}
break;
case 4:
#line 56 "grammar"
{ /***********************************************
			   * Parse the list of output signals for the fsm.
			   * Once the list has been parsed, add the
			   * signals to the symbol table.
			   ***********************************************
			   */
			  if(TypesAreOkay(yyvsp[-1].idval, ILLEGAL))
			  {  AddListItems(OUTPUTS, yyvsp[-1].idval);
			  }
			  else
			  {  fprintf(stderr,
				 "Bad identifier '%s' in OUTPUT list.\n",
				 yyvsp[-1].idval);
			     error("Error");
			     exit(1);
			  }

			}
break;
case 5:
#line 74 "grammar"
{}
break;
case 6:
#line 77 "grammar"
{ /**********************************************
			  ** Initialize the reset statename and signal
			  ** Can't check that the state exists, since
			  ** we havn't parsed the state names yet. Well
			  ** check it after all the parsing is done.
			  ** Check the input now.
			  ***********************************************
			  */
			  ResetState = yyvsp[-1].nsval;
			  ResetSignal = yyvsp[-3].chval;
			  if (TypeFromName(ResetSignal) != INPUTS){
			     fprintf(stderr,
			       "Reset signal %s is not in input list\n",
			       ResetSignal);
			     error("Error");
			     exit(1);
			   }
			}
break;
case 7:
#line 96 "grammar"
{}
break;
case 8:
#line 99 "grammar"
{
			yyval.nsval = yyvsp[0].nsval;
			}
break;
case 9:
#line 103 "grammar"
{
			yyval.nsval = yyvsp[0].nsval;
			}
break;
case 10:
#line 108 "grammar"
{ /***********************************************
			   * Start making a list of state descriptions.
			   ***********************************************
			   */
			   yyvsp[0].sval->next=(struct StateRecord *) 0;
			   yyval.sval=yyvsp[0].sval;
			}
break;
case 11:
#line 116 "grammar"
{ /***********************************************
			   * Add another state to the state list.  Note
			   * they are put on in reverse order.
			   ***********************************************
			   */
			   yyvsp[0].sval->next=yyvsp[-1].sval;
			   yyval.sval=yyvsp[0].sval;
			}
break;
case 12:
#line 126 "grammar"
{ /***********************************************
			   * Return an ITEM record
			   ***********************************************
			   */
			  yyval.idval=NewIdRec(yyvsp[0].chval);
			}
break;
case 13:
#line 133 "grammar"
{ /***********************************************
			   * Add an ITEM record to the list of identifiers
			   * Note that these are listed in reverse order.
			   ***********************************************
			   */
			  struct IdList * temp;
			  temp=NewIdRec(yyvsp[0].chval);
			  temp->next=yyvsp[-1].idval;
			  yyval.idval=temp;
			}
break;
case 14:
#line 145 "grammar"
{ /************************************************
			  ** Construct a new output record. 
			  ** Dummy up a 1 bit.
			  *************************************************
			  */
			  yyval.aval=NewAssertRec(yyvsp[0].chval,NewIdRec("1"));
			}
break;
case 15:
#line 153 "grammar"
{ /************************************************
			  ** Construct a new output record. 
			  *************************************************
			  */
			  yyval.aval=NewAssertRec(yyvsp[-2].chval,yyvsp[0].idval);
			}
break;
case 16:
#line 161 "grammar"
{ /************************************************
			  ** Return the AssertList record.
			  *************************************************
			  */
			  yyval.aval=yyvsp[0].aval;
			}
break;
case 17:
#line 168 "grammar"
{ /************************************************
			  ** Add the AssertList record to the list of outputs.
			  ** Note that these are listed in reverse order.
			  *************************************************
			  */
			  yyvsp[0].aval->next=yyvsp[-1].aval;
			  yyval.aval=yyvsp[0].aval;
			}
break;
case 18:
#line 178 "grammar"
{ /***********************************************
			   * Put the state name and signals into the 
			   * record built by Control.  Check to see that
			   * the state name is not already defined.
			   ***********************************************
			   */
			   if(TypeFromName(yyvsp[-2].chval)== -1) /*Undefined*/
			   { 
			     yyvsp[0].sval->name  =yyvsp[-2].chval;
			     AddState(yyvsp[-2].chval);
			     StateBaseName=yyvsp[-2].chval;
			     StateOffset=0;
			     yyval.sval=yyvsp[0].sval;
			   }
			   else
			   { fprintf(stderr,
			      "State '%s' is already defined.\n", yyvsp[-2].chval);
			     error("Error");
			     exit(1);
			   }
			}
break;
case 19:
#line 201 "grammar"
{ /*
			   * This is #4
			   */
			   BitListLength=IdListLength(yyvsp[0].idval);
			}
break;
case 20:
#line 207 "grammar"
{ /***********************************************
			   * Build a control record and return it.
			   ***********************************************
			   */
			  if(TypesAreOkay(yyvsp[-4].idval, INPUTS))
			     yyval.sval=NewStateRecord(yyvsp[-4].idval, yyvsp[-1].cval, yyvsp[0].nsval);
			  else
			  {  /*fprintf(stderr, 
				"Bad identifier '%s' in CASE selector.\n",
				     $3);
			     error("Error");
			     */
			     exit(1);
			  }
			}
break;
case 21:
#line 223 "grammar"
{ /***********************************************
			   * Transform this into a case statement.
			   * BitList is #2.  State for transition is #4.
			   * #6 is the default next state.
			   ***********************************************
			   */
			  if(TypeFromName(yyvsp[-5].chval)!=INPUTS)
			  {  fprintf(stderr, "Bad input '%s' in IF.\n",
			  		yyvsp[-5].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-3].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-3].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'then' state '%s' in IF.\n",
					yyvsp[-3].nsval->name);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-1].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-1].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'else' state '%s' in IF.\n",
					yyvsp[-1].nsval->name);
			     error("Error");
			     exit(1);
			  }
			  else
			   yyval.sval=NewStateRecord(NewIdRec(yyvsp[-5].chval),
			      NewCaseLine(NewIdRec("1"), yyvsp[-3].nsval), yyvsp[-1].nsval);
			}
break;
case 22:
#line 256 "grammar"
{ /***********************************************
			   * Transform this into a case statement.
			   * As above.  #7 is the default next state.
			   ***********************************************
			   */
			  if(TypeFromName(yyvsp[-5].chval)!=INPUTS)
			  {  fprintf(stderr, "Bad input '%s' in IF.\n",
					yyvsp[-5].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-3].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-3].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'then' state '%s' in IF.\n",
					yyvsp[-3].nsval->name);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-1].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-1].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'else' state '%s' in IF.\n",
					yyvsp[-1].nsval->name);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.sval=NewStateRecord(NewIdRec(yyvsp[-5].chval),
				NewCaseLine(NewIdRec("0"), yyvsp[-3].nsval), yyvsp[-1].nsval);
			}
break;
case 23:
#line 288 "grammar"
{ /***********************************************
			   * Case statement with NIL input and NIL cases.
			   ***********************************************
			   */
			  if((TypeFromName(yyvsp[-1].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-1].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in GOTO.\n",
					yyvsp[-1].nsval->name);
			     error("Error");
			     exit(1);
			  }
			   yyval.sval=NewStateRecord((struct IdList *) 0,
			      (struct CaseItem *) 0, yyvsp[-1].nsval);
			}
break;
case 24:
#line 304 "grammar"
{ /***********************************************
			   * Make a new record holding a bitlist and the
			   * identifier naming a NEXT state.
			   ***********************************************
			   */
			  int temp;
			  temp=IdListLength(yyvsp[-3].idval);
			  if(BitListLength>temp)
			  { error("Too few selectors in CASE line\n");
			    exit(1);
			  }
			  else
			  if(BitListLength<temp)
			  { error("Too many selectors in CASE line\n");
			    exit(1);
			  }
			  if((TypeFromName(yyvsp[-1].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-1].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in CASE.\n",
					yyvsp[-1].nsval->name);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.cval=NewCaseLine(yyvsp[-3].idval, yyvsp[-1].nsval);
			}
break;
case 25:
#line 332 "grammar"
{ /***********************************************
			   * Add the new case statement to the linked list
			   * Note that these appear in reverse order.
			   ***********************************************
			   */
			  yyvsp[0].cval->next=yyvsp[-1].cval;
			  yyval.cval=yyvsp[0].cval;
			  /*PrintCaseList($2);*/
			}
break;
case 26:
#line 342 "grammar"
{ /***********************************************
			   * Pass the semantic attribute back up.
			   ***********************************************
			   */
			  yyval.cval=yyvsp[0].cval;
			}
break;
case 27:
#line 350 "grammar"
{ /***********************************************
			   * Return the integer value of '0'
			   ***********************************************
			   */
			  yyval.idval=NewIdRec("0");
			}
break;
case 28:
#line 357 "grammar"
{ /***********************************************
			   * Return the integer value of '1'
			   ***********************************************
			   */
			  yyval.idval=NewIdRec("1");
			}
break;
case 29:
#line 364 "grammar"
{ /***********************************************
			   * Return the integer value of '-'
			   ***********************************************
			   */
			  yyval.idval=NewIdRec("-"); /*DONTCARE*/
			}
break;
case 30:
#line 372 "grammar"
{ /***********************************************
			   * Add an ITEM record to the list of bits.
			   * Note that these are listed in reverse order.
			   ***********************************************
			   */
			  yyvsp[0].idval->next=yyvsp[-1].idval;
			  yyval.idval=yyvsp[0].idval;
			}
break;
case 31:
#line 381 "grammar"
{ /***********************************************
			   * Pass the bit record upward.
			   ***********************************************
			   */
			  yyval.idval=yyvsp[0].idval;
			}
break;
case 32:
#line 389 "grammar"
{ /***********************************************
			   * Return the identifier for the next state.
			   ***********************************************
			   */
			  if((TypeFromName(yyvsp[-1].nsval->name)==INPUTS)||
			     (TypeFromName(yyvsp[-1].nsval->name)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in ENDCASE.\n",
					yyvsp[-1].nsval->name);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.nsval=yyvsp[-1].nsval;
			}
break;
case 33:
#line 404 "grammar"
{ /***********************************************
			   * Return next state = NIL.
			   ***********************************************
			   */
			  yyval.nsval=(struct NextState *) 0; /*Null*/
			}
break;
case 34:
#line 412 "grammar"
{ /***********************************************
			  ** No signals asserted on this transition.
			  ** Create a next state record with no assertion list.
			  ************************************************
			  */
			  yyval.nsval=NewNextState(yyvsp[0].chval,NULL);
			}
break;
case 35:
#line 420 "grammar"
{ /***********************************************
			  ** Return a next state record with name and 
			  ** assertions set.
			  ************************************************
			  */
			  if (AssertTypesAreOkay(yyvsp[-1].aval))
				yyval.nsval=NewNextState(yyvsp[-3].chval,yyvsp[-1].aval);
			  else
			  {  fprintf(stderr,
		   "Non-OUTPUT in assertion list on transition to state %s.\n",
			             yyvsp[-3].chval);
			     error("Error");
			     exit(1);
			  }
			}
break;
#line 873 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
