struct AssertList
   { char	   	* name;
     char	     	  bit;
     struct AssertList 	* next;
   };
struct IdList
   { char          * name;
     struct IdList * next;
   };
struct NextState
   { char	       * name;
     struct AssertList * Assert;
   };
struct CaseItem
   { struct IdList   * bits;
     char            * StateName;
     struct AssertList   * Assert;
     struct CaseItem * next;
   };
struct StateRecord
   { char               * name;
     struct IdList      * selector;
     struct CaseItem    * cases;
     struct StateRecord * next;
   };

extern struct IdList * NewIdRec();
extern struct StateRecord * NewStateRecord();
extern struct CaseItem * NewCaseLine();
extern struct NextState * NewNextState();
extern struct AssertList * NewAssertRec();
