#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 3 "grammar"
#include <stdio.h>
#include "LookupDefs.i"
#include "ParserDefs.i"

int BitListLength;
struct StateRecord * ParserList;
extern int StateOffset;
extern char * StateBaseName;

#line 13 "grammar"
typedef union { int                   ival;
	 char               * chval;
	 struct IdList      * idval;
	 struct CaseItem    *  cval;
	 struct StateRecord *  sval;
       } YYSTYPE;
#line 34 "y.tab.c"
#define YYERRCODE 256
#define IDENTIFIER 257
#define INPUT 258
#define OUTPUT 259
#define ASSERT 260
#define CASE 261
#define IF 262
#define THEN 263
#define ELSE 264
#define ARROW 265
#define DEFAULT 266
#define ENDCASE 267
#define GOTO 268
#define NOT 269
#define COLON 270
#define SEMICOLON 271
#define LPAREN 272
#define RPAREN 273
#define ONEBIT 274
#define ZEROBIT 275
#define DONTCAREBIT 276
const short yylhs[] = {                                        -1,
    0,    6,    6,    7,    7,    8,    8,    1,    1,    9,
    9,    4,    4,   13,   10,   10,   10,   10,   10,   10,
   10,   11,   12,   12,    3,    3,    3,    2,    2,    5,
    5,
};
const short yylen[] = {                                         2,
    3,    4,    0,    4,    0,    1,    2,    1,    2,    4,
    3,    0,    3,    0,    7,    5,    7,    6,    8,    3,
    0,    4,    2,    1,    1,    1,    1,    2,    1,    4,
    2,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    8,    0,    0,    0,
    0,    0,    6,    9,    2,    0,    0,    0,    0,    7,
    4,    0,    0,    0,    0,    0,   11,   10,   13,    0,
    0,    0,    0,    0,    0,    0,   20,    0,    0,    0,
    0,    0,   16,    0,   26,   25,   27,    0,   29,   24,
    0,    0,    0,   18,    0,   28,    0,   15,   23,   17,
    0,    0,    0,   31,   19,   22,    0,   30,
};
const short yydgoto[] = {                                       2,
    8,   48,   49,   19,   58,    3,    6,   12,   13,   27,
   50,   51,   38,
};
const short yysindex[] = {                                   -242,
 -264,    0, -245, -231, -241, -250,    0, -254, -231, -230,
 -232, -250,    0,    0,    0, -253, -232, -231, -224,    0,
    0, -224, -252, -229, -244, -227,    0,    0,    0, -231,
 -218, -216, -221, -210, -208, -212,    0, -217, -256, -202,
 -222, -200,    0, -225,    0,    0,    0, -243,    0,    0,
 -240, -213, -198,    0, -197,    0, -223,    0,    0,    0,
 -209, -207, -196,    0,    0,    0, -206,    0,
};
const short yyrindex[] = {                                   -247,
    0,    0, -246,    0,    0,    0,    0,    0,    0,    0,
    1,   63,    0,    0,    0,    0,    1,    0,    2,    0,
    0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -205,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
   -9,    0,   18,   50,    0,    0,    0,    0,   57,   48,
   20,    0,    0,
};
#define YYTABLESIZE 272
const short yytable[] = {                                      16,
   12,   21,   14,   14,   14,    4,   10,   42,   23,    3,
    5,    3,   31,    5,   43,    1,   15,   21,   29,   11,
   34,   55,    3,    5,   32,    7,   57,   18,    9,   33,
   45,   46,   47,   45,   46,   47,   24,   25,   53,   17,
   36,   63,   30,   26,   35,   54,   14,   64,   39,   37,
   40,   45,   46,   47,   44,   41,   52,   60,   61,   62,
   67,   65,    1,   66,   68,   56,   22,   14,   20,   28,
   59,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   12,   21,    0,
    0,   12,   12,    0,    0,    0,    0,    0,   12,    0,
   12,   21,
};
const short yycheck[] = {                                       9,
    0,    0,  257,  257,  257,  270,  257,  264,   18,  257,
  257,  259,  257,  259,  271,  258,  271,  271,  271,  270,
   30,  265,  270,  270,  269,  257,  267,  260,  270,  257,
  274,  275,  276,  274,  275,  276,  261,  262,  264,  270,
  257,  265,  272,  268,  263,  271,  257,  271,  257,  271,
  263,  274,  275,  276,  257,  273,  257,  271,  257,  257,
  257,  271,    0,  271,  271,   48,   17,  273,   12,   22,
   51,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  257,   -1,
   -1,  261,  262,   -1,   -1,   -1,   -1,   -1,  268,   -1,
  270,  270,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 276
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IDENTIFIER","INPUT","OUTPUT",
"ASSERT","CASE","IF","THEN","ELSE","ARROW","DEFAULT","ENDCASE","GOTO","NOT",
"COLON","SEMICOLON","LPAREN","RPAREN","ONEBIT","ZEROBIT","DONTCAREBIT",
};
const char * const yyrule[] = {
"$accept : program",
"program : InputList OutputList StateList",
"InputList : INPUT COLON IdentifierList SEMICOLON",
"InputList :",
"OutputList : OUTPUT COLON IdentifierList SEMICOLON",
"OutputList :",
"StateList : State",
"StateList : StateList State",
"IdentifierList : IDENTIFIER",
"IdentifierList : IdentifierList IDENTIFIER",
"State : IDENTIFIER COLON Signals Control",
"State : COLON Signals Control",
"Signals :",
"Signals : ASSERT IdentifierList SEMICOLON",
"$$1 :",
"Control : CASE LPAREN IdentifierList $$1 RPAREN Cases DefaultCase",
"Control : IF IDENTIFIER THEN IDENTIFIER SEMICOLON",
"Control : IF IDENTIFIER THEN IDENTIFIER ELSE IDENTIFIER SEMICOLON",
"Control : IF NOT IDENTIFIER THEN IDENTIFIER SEMICOLON",
"Control : IF NOT IDENTIFIER THEN IDENTIFIER ELSE IDENTIFIER SEMICOLON",
"Control : GOTO IDENTIFIER SEMICOLON",
"Control :",
"CaseStatement : BitList ARROW IDENTIFIER SEMICOLON",
"Cases : Cases CaseStatement",
"Cases : CaseStatement",
"Bit : ZEROBIT",
"Bit : ONEBIT",
"Bit : DONTCAREBIT",
"BitList : BitList Bit",
"BitList : Bit",
"DefaultCase : ENDCASE ARROW IDENTIFIER SEMICOLON",
"DefaultCase : ENDCASE SEMICOLON",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 437 "grammar"
#include "lex.yy.c"
#line 245 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 31 "grammar"
{ /***********************************************
			   * Return the parser data list in an external.
			   ***********************************************
			   */
			   ParserList=yyvsp[0].sval;
			   /*Generate($3);*/
			}
break;
case 2:
#line 40 "grammar"
{ /***********************************************
			   * Parse the list of input signals for the fsm.
			   * Once the list has been parsed, add the
			   * signals to the symbol table.
			   ***********************************************
			   */
			   AddListItems(INPUTS, yyvsp[-1].idval);
			}
break;
case 3:
#line 48 "grammar"
{}
break;
case 4:
#line 51 "grammar"
{ /***********************************************
			   * Parse the list of output signals for the fsm.
			   * Once the list has been parsed, add the
			   * signals to the symbol table.
			   ***********************************************
			   */
			  if(TypesAreOkay(yyvsp[-1].idval, ILLEGAL))
			  {  AddListItems(OUTPUTS, yyvsp[-1].idval);
			  }
			  else
			  {  fprintf(stderr,
				 "Bad identifier '%s' in OUTPUT list.\n",
				 yyvsp[-1].idval);
			     error("Error");
			     exit(1);
			  }

			}
break;
case 5:
#line 69 "grammar"
{}
break;
case 6:
#line 72 "grammar"
{ /***********************************************
			   * Start making a list of state descriptions.
			   ***********************************************
			   */
			   yyvsp[0].sval->next=(struct StateRecord *) 0;
			   yyval.sval=yyvsp[0].sval;
			}
break;
case 7:
#line 80 "grammar"
{ /***********************************************
			   * Add another state to the state list.  Note
			   * they are put on in reverse order.
			   ***********************************************
			   */
			   yyvsp[0].sval->next=yyvsp[-1].sval;
			   yyval.sval=yyvsp[0].sval;
			}
break;
case 8:
#line 90 "grammar"
{ /***********************************************
			   * Return an ITEM record
			   ***********************************************
			   */
			  yyval.idval=NewIdRec(yyvsp[0].chval);
			}
break;
case 9:
#line 97 "grammar"
{ /***********************************************
			   * Add an ITEM record to the list of identifiers
			   * Note that these are listed in reverse order.
			   ***********************************************
			   */
			  struct IdList * temp;
			  temp=NewIdRec(yyvsp[0].chval);
			  temp->next=yyvsp[-1].idval;
			  yyval.idval=temp;
			}
break;
case 10:
#line 109 "grammar"
{ /***********************************************
			   * Put the state name and signals into the 
			   * record built by Control.  Check to see that
			   * the state name is not already defined.
			   ***********************************************
			   */
			   if(TypeFromName(yyvsp[-3].chval)== -1) /*Undefined*/
			   { yyvsp[0].sval->assert=yyvsp[-1].idval;
			     yyvsp[0].sval->name  =yyvsp[-3].chval;
			     AddState(yyvsp[-3].chval);
			     StateBaseName=yyvsp[-3].chval;
			     StateOffset=0;
			     yyval.sval=yyvsp[0].sval;
			   }
			   else
			   { fprintf(stderr,
			      "State '%s' is already defined.\n", yyvsp[-3].chval);
			     error("Error");
			     exit(1);
			   }
			}
break;
case 11:
#line 131 "grammar"
{  char * RelativeStateName();

			   yyvsp[0].sval->assert=yyvsp[-1].idval;
			   StateOffset++;
			   yyvsp[0].sval->name=RelativeStateName();
			   AddState(yyvsp[0].sval->name);
			   yyval.sval=yyvsp[0].sval;
			}
break;
case 12:
#line 141 "grammar"
{ /***********************************************
			   * Return the null list of signals.
			   ***********************************************
			   */
			  yyval.idval=(struct IdList *) 0;
			}
break;
case 13:
#line 148 "grammar"
{ /***********************************************
			   * Return a list of names of signals.  Complain
			   * if any are not outputs.
			   ***********************************************
			   */
			  if(TypesAreOkay(yyvsp[-1].idval, OUTPUTS))
			     yyval.idval=yyvsp[-1].idval;
			  else
			  {  /*fprintf(stderr, "Bad identifier '%s' in ASSERT.\n",
				     $2);
			     error("Error");
			     */
			     exit(1);
			  }
			}
break;
case 14:
#line 165 "grammar"
{ /*
			   * This is #4
			   */
			   BitListLength=IdListLength(yyvsp[0].idval);
			}
break;
case 15:
#line 171 "grammar"
{ /***********************************************
			   * Build a control record and return it.
			   ***********************************************
			   */
			  if(TypesAreOkay(yyvsp[-4].idval, INPUTS))
			     yyval.sval=NewStateRecord(yyvsp[-4].idval, yyvsp[-1].cval, yyvsp[0].chval);
			  else
			  {  /*fprintf(stderr, "Bad identifier '%s' in ASSERT.\n",
				     $3);
			     error("Error");
			     */
			     exit(1);
			  }
			}
break;
case 16:
#line 186 "grammar"
{ /***********************************************
			   * Transform this into a case statement.
			   * BitList is #2.  State for transition is #4.
			   * "(struct IdList *) 0" shows standard default
			   * for next state.
			   ***********************************************
			   */
			  if(TypeFromName(yyvsp[-3].chval)!=INPUTS)
			  {  fprintf(stderr, "Bad input '%s' in IF.\n",
				     yyvsp[-3].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in IF.\n",
				     yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			      yyval.sval=NewStateRecord(NewIdRec(yyvsp[-3].chval),
				 NewCaseLine(NewIdRec("1"), yyvsp[-1].chval),
			         (char *) 0);
			}
break;
case 17:
#line 213 "grammar"
{ /***********************************************
			   * Transform this into a case statement.
			   * As above.  #6 is the default next state.
			   ***********************************************
			   */
			  if(TypeFromName(yyvsp[-5].chval)!=INPUTS)
			  {  fprintf(stderr, "Bad input '%s' in IF.\n",
			  		yyvsp[-5].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-3].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-3].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'then' state '%s' in IF.\n",
					yyvsp[-3].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'else' state '%s' in IF.\n",
					yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			   yyval.sval=NewStateRecord(NewIdRec(yyvsp[-5].chval),
			      NewCaseLine(NewIdRec("1"), yyvsp[-3].chval), yyvsp[-1].chval);
			}
break;
case 18:
#line 245 "grammar"
{ /***********************************************
			   * Transform this into a case statement.
			   * BitList is #3.  State for transition is #5.
			   * "(struct IdList *) 0" shows standard default
			   * for next state.
			   ***********************************************
			   */
			  if(TypeFromName(yyvsp[-3].chval)!=INPUTS)
			  {  fprintf(stderr, "Bad input '%s' in IF.\n",
					yyvsp[-3].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in IF.\n",
					yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.sval=NewStateRecord(NewIdRec(yyvsp[-3].chval), 
				NewCaseLine(NewIdRec("0"), yyvsp[-1].chval),
			      (char *) 0);
			}
break;
case 19:
#line 272 "grammar"
{ /***********************************************
			   * Transform this into a case statement.
			   * As above.  #7 is the default next state.
			   ***********************************************
			   */
			  if(TypeFromName(yyvsp[-5].chval)!=INPUTS)
			  {  fprintf(stderr, "Bad input '%s' in IF.\n",
					yyvsp[-5].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-3].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-3].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'then' state '%s' in IF.\n",
					yyvsp[-3].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad 'else' state '%s' in IF.\n",
					yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.sval=NewStateRecord(NewIdRec(yyvsp[-5].chval),
				NewCaseLine(NewIdRec("0"), yyvsp[-3].chval), yyvsp[-1].chval);
			}
break;
case 20:
#line 304 "grammar"
{ /***********************************************
			   * Case statement with NIL input and NIL cases.
			   ***********************************************
			   */
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in GOTO.\n",
					yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			   yyval.sval=NewStateRecord((struct IdList *) 0,
			      (struct CaseItem *) 0, yyvsp[-1].chval);
			}
break;
case 21:
#line 320 "grammar"
{ /***********************************************
			   * Nil next state means to go to next sequential
			   ***********************************************
			   */
			   yyval.sval=NewStateRecord((struct IdList *) 0,
			      (struct CaseItem *) 0, (char *) 0);
			}
break;
case 22:
#line 329 "grammar"
{ /***********************************************
			   * Make a new record holding a bitlist and the
			   * identifier naming a NEXT state.
			   ***********************************************
			   */
			  int temp;
			  temp=IdListLength(yyvsp[-3].idval);
			  if(BitListLength>temp)
			  { error("Too few selectors in CASE line\n");
			    exit(1);
			  }
			  else
			  if(BitListLength<temp)
			  { error("Too many selectors in CASE line\n");
			    exit(1);
			  }
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in CASE.\n",
					yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.cval=NewCaseLine(yyvsp[-3].idval, yyvsp[-1].chval);
			}
break;
case 23:
#line 357 "grammar"
{ /***********************************************
			   * Add the new case statement to the linked list
			   * Note that these appear in reverse order.
			   ***********************************************
			   */
			  yyvsp[0].cval->next=yyvsp[-1].cval;
			  yyval.cval=yyvsp[0].cval;
			  /*PrintCaseList($2);*/
			}
break;
case 24:
#line 367 "grammar"
{ /***********************************************
			   * Pass the semantic attribute back up.
			   ***********************************************
			   */
			  yyval.cval=yyvsp[0].cval;
			}
break;
case 25:
#line 375 "grammar"
{ /***********************************************
			   * Return the integer value of '0'
			   ***********************************************
			   */
			  yyval.idval=NewIdRec("0");
			}
break;
case 26:
#line 382 "grammar"
{ /***********************************************
			   * Return the integer value of '1'
			   ***********************************************
			   */
			  yyval.idval=NewIdRec("1");
			}
break;
case 27:
#line 389 "grammar"
{ /***********************************************
			   * Return the integer value of '-'
			   ***********************************************
			   */
			  yyval.idval=NewIdRec("-"); /*DONTCARE*/
			}
break;
case 28:
#line 397 "grammar"
{ /***********************************************
			   * Add an ITEM record to the list of bits.
			   * Note that these are listed in reverse order.
			   ***********************************************
			   */
			  yyvsp[0].idval->next=yyvsp[-1].idval;
			  yyval.idval=yyvsp[0].idval;
			}
break;
case 29:
#line 406 "grammar"
{ /***********************************************
			   * Pass the bit record upward.
			   ***********************************************
			   */
			  yyval.idval=yyvsp[0].idval;
			}
break;
case 30:
#line 414 "grammar"
{ /***********************************************
			   * Return the identifier for the next state.
			   ***********************************************
			   */
			  if((TypeFromName(yyvsp[-1].chval)==INPUTS)||
			     (TypeFromName(yyvsp[-1].chval)==OUTPUTS))
			  {  fprintf(stderr, "Bad state '%s' in ENDCASE.\n",
					yyvsp[-1].chval);
			     error("Error");
			     exit(1);
			  }
			  else
			     yyval.chval=yyvsp[-1].chval;
			}
break;
case 31:
#line 429 "grammar"
{ /***********************************************
			   * Return next state = NIL.
			   ***********************************************
			   */
			  yyval.chval=(char *) 0; /*Null*/
			}
break;
#line 896 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
